#procedure massivefofa(j,code,printfofa)

* This file is part of aITALC
* Copyright (C) 2004 Alejandro Lorca <alejandro.lorca@desy.de>
*------------------------------------------------------------- 
** Procedure that calculates and save the form factors as Alex b-paper

** j={number of processed diagram}, as number in Info.ps pages
** code={15,lr} depending if you wish ident/gamma5 basis or left/right 
** printfofa = 1/0 print/not the form factors in fortran mode

** The final variable is saved as: "FF`ch'`i1'`i2'D`j'" 
** in the file FF`code'D`j'

** Begun on, 11/02/03


** Here we have a small point, chain 2 appear first, and chain 1 last, so
** f2 stands for 1_15, f3 for 1_51, f6 for 2_15 and so ... 

** The main problem arises for non-s channel fermion chains, so for instance in
** bhabha or moeller scattering
id gamma5(line?)=g5(line);
id ident(line?)=g1(line);
id gamma(iline?,mu0?)=g_(iline,mu0);

#include legsindexdef.inc

#do i2=1,`i2max'
  #if     `i2'==1
    #define k1 "1"
    #define k2 "1"
  #elseif `i2'==2
    #define k1 "1"
    #define k2 "5"
  #elseif `i2'==3
    #define k1 "5"
    #define k2 "1"
  #elseif `i2'==4
    #define k1 "5"
    #define k2 "5"
  #endif

*The definitions of our matrix elements

#do ic=1,`EXTFERMICURRENTS'
    #redefine pch{`ic'} "`P`FERMIONCHANNEL'{`ic'}'"
#enddo

b g_,g1,g5;
.sort
keep brackets;

id g_(1,si1,si2)   *g`k1'(1)*g_(2,si1,si2)   *g`k2'(2)=matrixe(`FERMIONCHANNEL',9,`i2');
id g_(1,si1,`pch1')*g`k1'(1)*g_(2,si1,`pch2')*g`k2'(2)=matrixe(`FERMIONCHANNEL',8,`i2');
id g_(1,si1,`pch1')*g`k1'(1)*g_(2,si1)       *g`k2'(2)=matrixe(`FERMIONCHANNEL',7,`i2');
id g_(1,si1)       *g`k1'(1)*g_(2,si1,`pch2')*g`k2'(2)=matrixe(`FERMIONCHANNEL',6,`i2');
id g_(1,si1)       *g`k1'(1)*g_(2,si1)       *g`k2'(2)=matrixe(`FERMIONCHANNEL',5,`i2');
id g_(1,`pch1')    *g`k1'(1)*g_(2,`pch2')    *g`k2'(2)=matrixe(`FERMIONCHANNEL',4,`i2');
id g_(1,`pch1')    *g`k1'(1)                 *g`k2'(2)=matrixe(`FERMIONCHANNEL',3,`i2');
id                  g`k1'(1)*g_(2,`pch2')    *g`k2'(2)=matrixe(`FERMIONCHANNEL',2,`i2');
id                  g`k1'(1)                 *g`k2'(2)=matrixe(`FERMIONCHANNEL',1,`i2');

#enddo

.sort

*print +s;
*---------------------------------------------------------------
* Avoiding formfactoring as Global variables, but just like functions

.store

nwrite statistics;
** The final variable is saved as: "FF`ch'`i1'`i2'D`j'" 
** in the file FF`code'D`j'

save FF`processname'/FF`code'D`j'.sav [Amplitude,`j'];

#endprocedure
*---------------------------------------------------------------
* And declaring the new Form Factors variables...
hide Rqcopy;
#do ch={`fermioncurrentsnames'}
  #do i1=1,`i1max'
    #do i2=1,`i2max'
       G FF`ch'`i1'`i2'D`j'=Rqcopy;
       if ( match(matrixe(`ch',`i1',`i2')) = 0 ) discard;
       id matrixe(`ch',`i1',`i2')=1;
       .sort
       hide  FF`ch'`i1'`i2'D`j';
    #enddo
  #enddo
#enddo
.sort

* Test value informs if the result is consistent/incorrect (0/other)
#if `printfofa' == 1
L test=Rqcopy
#do ch={`fermioncurrentsnames'}
  #do i1=1,`i1max'
    #do i2=1,`i2max'
      - FF`ch'`i1'`i2'D`j'*matrixe(`ch',`i1',`i2')
    #enddo
  #enddo
#enddo
;

print test;

** If you want better Passarino-Veltman than LoopTools
*#call LTtoPV()

  .sort
  unhide;
  nunhide Rqcopy;
  b gamma5,gamma,e,sw,i_,Pi;
  format fortran;
  print +s +f;
#elseif `printfofa' == 0
#else
  #message [massivefofa: `printfofa' argument neq 0/1. stop]
#endif

** Now we .sort to declare: Rq untouched till the .end, and drop others
.sort
drop Rqcopy,test;
unhide;


** In order to store we decide either 15 or lr stuff

.store
nwrite statistics;

** The final variable is saved as: "FF`ch'`i1'`i2'D`j'" 
** in the file FF`code'D`j'

save FF`processname'/FF`code'D`j'.sav
#do ch={`fermioncurrentsnames'}
  #do i1=1,`i1max'
    #do i2=1,`i2max'
      FF`ch'`i1'`i2'D`j'
    #enddo
  #enddo
#enddo
;

*Only if running all the diagrams under form.
delete storage;

#endprocedure
*$Id: massivefofa.prc,v 1.7 2004/10/08 14:28:11 alorca Exp $
