C File <cden.f> containing the function CDEN(a,b) = 1/(a-b) as propagator
C This file is part of aITALC
C Copyright (C) 2003,2004 Alejandro Lorca <alejandro.lorca@desy.de>

      double complex function CDEN(a,b)
      implicit none
      double precision a
      double complex b

      if ((a.EQ.DBLE(b)).AND.(DIMAG(b).EQ.0d0)) then
        CDEN= 0
        print *,'CD: propagator on exact resonance with no width'
        stop
      elseif (a.LT.0d0) then
** Negative propagators don't develop imaginary parts
        CDEN = 1/DCMPLX(a-DBLE(b))
      else
        CDEN = 1/(DCMPLX(a)-b)
      endif

      return
      end
CC $Id: cden.f,v 1.6 2004/10/07 15:05:11 alorca Exp $
